C Open Existing File
      interface to integer*2 function lopen
     +  [pascal,alias:'_lopen'](filename,mode)
      character*1 filename[reference]
      integer*2   mode[value]
C        MODE =
C            0     Read only
C            1     Write only
C            2     Read and Write
      end

C Create File (erases old file if one exists)
      interface to integer*2 function lcreat
     +  [pascal,alias:'_lcreat'](filename,mode)
      character*1 filename[reference]
      integer*2   mode[value]
C        MODE =
C            0     Read and Write
C            1     Read only
C            2     Hidden
C            3     System
      end

C Close file (use with files opened by lcreat or lopen)
      interface to integer*2 function lclose
     +  [pascal,alias:'_lclose'](handle)
      integer*2   handle[value]
      end

C hread and hwrite can read and write a buffer larger than 64K
      interface to integer*4 function hwrite
     +  [pascal,alias:'_hwrite'](handle,buf,size)
      character*1 buf[reference]
      integer*2   handle[value]
      integer*4   size[value]
      end

      interface to integer*4 function hread
     +  [pascal,alias:'_hread'](handle,buf,size)
      character*1 buf[reference]
      integer*2   handle[value]
      integer*4   size[value]
      end

C Seek to points in a file (use to provide direct file access)
      interface to integer*4 function llseek
     +  [pascal,alias:'_llseek'](handle,offset,origin)
      integer*4   offset[value]
      integer*2   handle[value],origin[value]
C        Origin =
C            0     Offset from start of file
C            1     Offset from current position
C            2     Offset from end of file
      end

C  The following 2 functions (BFWRITE and BFREAD) are examples of
C  using the functions _hwrite and _hread to read and write
C  binary REAL*4 data. Additional function names could be defined
C  to read or write other data types. For example, an interface
C  could be defined for BIWRITE to write INTEGER*4 data. It would
C  be identical to the interface statement of BFWRITE, except
C  that BUF would be declared to have type INTEGER*4.

C  Read and Write Binary Floating point data
      interface to integer*4 function bfwrite
     +  [pascal,alias:'_hwrite'](handle,buf,size)
      real*4 buf[reference](1)
      integer*2   handle[value]
      integer*4   size[value]
      end

      interface to integer*4 function bfread
     +  [pascal,alias:'_hread'](handle,buf,size)
      real*4 buf[reference](1)
      integer*2   handle[value]
      integer*4   size[value]
      end

C Test writing data (ASCII and Binary)
      subroutine testwrite()

      character*30 s
      integer*2 handle, lclose,lcreat
      integer*4 i, hwrite,bfwrite
      real*4 x(20000)  !Note: X is 80000 bytes

      handle = lcreat('testbf.out'C,0) !Create new file
      do i=2,20000
        x(i)=x(i-1)+3.1415926
      end do
      i = bfwrite(handle, x, 80000)    !Binary write all of X
      i = lclose(handle)

      handle = lcreat('test.out'C,0)   !Create new file
      !Use an internal write to format output text
      write(s,'(''Test One'',F12.5)') 51.763
      i = hwrite(handle, s, 20)        !then write output text
      i = lclose(handle)
      end

C Test reading binary data
      subroutine readbinary()
      character*24 s
      integer*2 j,handle, lclose,lopen,lcreat
      integer*4 i, hwrite,bfread
      real*4 x(20000)  !Note: X is 80000 bytes

      handle = lopen('testbf.out'C,2) !Open existing file
      i = bfread(handle, x, 80000)    !Binary read all of X
      i = lclose(handle)

      handle = lcreat('testbf_o.out'C,0) !Create new file
      do j=1,4
         write(s,'(F16.5)') x(j)      !Convert to text
         i = hwrite(handle, s, 16)    !Write formatted output
      end do
      write(s,'(F16.5)') x(20000)
      i = hwrite(handle, s, 16)
      i = lclose(handle)
      end

C Test random access to file
      subroutine testseek()
      character*40 s
      integer*2 handle, lclose,lopen
      integer*4 i, hwrite,llseek,hread

      handle = lopen('test.out'C,2)
      i = llseek(handle, 4, 0)        !Position to 4 bytes from start
      i = hread(handle, s, 16)        !Read 16 characters
      i = llseek(handle, 7, 0)        !Position to 7 bytes from start
      i = hwrite(handle, s, 16)       !Overwrite from position 7 on
      i = lclose(handle)
      end
